Index: buildings.cpp
===================================================================
--- buildings.cpp	(revision 3442)
+++ buildings.cpp	(working copy)
@@ -277,7 +277,6 @@
 //--------------------------------------------------------------------------
 void cBuilding::draw (SDL_Rect* screenPos, cGameGUI& gameGUI)
 {
-	SDL_Rect dest, tmp;
 	float factor = (float) gameGUI.getTileSize() / 64.0f;
 	cPlayer* activePlayer = gameGUI.getClient()->getActivePlayer();
 	// draw the damage effects
@@ -296,7 +295,7 @@
 		}
 	}
 
-	dest.x = dest.y = 0;
+	SDL_Rect dest = {0, 0, 0, 0};
 	bool bDraw = false;
 	SDL_Surface* drawingSurface = gameGUI.getDCache()->getCachedImage (*this);
 	if (drawingSurface == NULL)
@@ -342,8 +341,8 @@
 	// draw the effect if necessary
 	if (data.powerOnGraphic && cSettings::getInstance().isAnimations() && (IsWorking || !data.canWork))
 	{
-		tmp = dest;
-		SDL_SetAlpha (uiData->eff, SDL_SRCALPHA, EffectAlpha);
+		SDL_Rect tmp = dest;
+		SDL_SetSurfaceAlphaMod (uiData->eff, EffectAlpha);
 
 		CHECK_SCALING (uiData->eff, uiData->eff_org, factor);
 		SDL_BlitSurface (uiData->eff, NULL, buffer, &tmp);
@@ -356,7 +355,7 @@
 
 				if (EffectAlpha > 220)
 				{
-					EffectAlpha = 255;
+					EffectAlpha = 254;
 					EffectInc = false;
 				}
 			}
@@ -376,7 +375,7 @@
 	// draw the mark, when a build order is finished
 	if ( ( (!BuildList.empty() && !IsWorking && BuildList[0].metall_remaining <= 0) || (data.canResearch && owner->researchFinished)) && owner == gameGUI.getClient()->getActivePlayer())
 	{
-		const Uint32 color = 0xFF00 - (0x1000 * (gameGUI.getAnimationSpeed() % 0x8));
+		const Uint32 color = 0xFF00FF00 - (0x1000 * (gameGUI.getAnimationSpeed() % 0x8));
 		const Uint16 max = data.isBig ? 2 * gameGUI.getTileSize() - 3 : gameGUI.getTileSize() - 3;
 		SDL_Rect d = {Sint16 (dest.x + 2), Sint16 (dest.y + 2), max, max};
 
@@ -392,7 +391,7 @@
 	// draw a colored frame if necessary
 	if (gameGUI.colorChecked())
 	{
-		const Uint32 color = *static_cast<Uint32*> (owner->getColorSurface()->pixels);
+		const Uint32 color = 0xFF000000 | *static_cast<Uint32*> (owner->getColorSurface()->pixels);
 		const Uint16 max = data.isBig ? 2 * gameGUI.getTileSize() - 1 : gameGUI.getTileSize() - 1;
 		SDL_Rect d = {Sint16 (dest.x + 1), Sint16 (dest.y + 1), max, max};
 
@@ -406,7 +405,7 @@
 		const int len = max / 4;
 		max -= 3;
 		SDL_Rect d = {Sint16 (dest.x + 2), Sint16 (dest.y + 2), max, max};
-		DrawSelectionCorner(buffer, d, len, gameGUI.getBlinkColor());
+		DrawSelectionCorner(buffer, d, len, 0xFF000000 | gameGUI.getBlinkColor());
 	}
 
 	// draw health bar
@@ -493,9 +492,9 @@
 		CHECK_SCALING (GraphicsData.gfx_big_beton, GraphicsData.gfx_big_beton_org, zoomFactor);
 
 		if (StartUp && cSettings::getInstance().isAlphaEffects())
-			SDL_SetAlpha (GraphicsData.gfx_big_beton, SDL_SRCALPHA, StartUp);
+			SDL_SetSurfaceAlphaMod (GraphicsData.gfx_big_beton, StartUp);
 		else
-			SDL_SetAlpha (GraphicsData.gfx_big_beton, SDL_SRCALPHA, 255);
+			SDL_SetSurfaceAlphaMod (GraphicsData.gfx_big_beton, 254);
 
 		SDL_BlitSurface (GraphicsData.gfx_big_beton, NULL, surface, &tmp);
 	}
@@ -503,12 +502,12 @@
 	{
 		CHECK_SCALING (UnitsData.ptr_small_beton, UnitsData.ptr_small_beton_org, zoomFactor);
 		if (StartUp && cSettings::getInstance().isAlphaEffects())
-			SDL_SetAlpha (UnitsData.ptr_small_beton, SDL_SRCALPHA, StartUp);
+			SDL_SetSurfaceAlphaMod (UnitsData.ptr_small_beton, StartUp);
 		else
-			SDL_SetAlpha (UnitsData.ptr_small_beton, SDL_SRCALPHA, 255);
+			SDL_SetSurfaceAlphaMod (UnitsData.ptr_small_beton, 254);
 
 		SDL_BlitSurface (UnitsData.ptr_small_beton, NULL, surface, &tmp);
-		SDL_SetAlpha (UnitsData.ptr_small_beton, SDL_SRCALPHA, 255);
+		SDL_SetSurfaceAlphaMod (UnitsData.ptr_small_beton, 254);
 	}
 }
 
@@ -531,7 +530,7 @@
 
 	// blit the players color and building graphic
 	if (data.hasPlayerColor) SDL_BlitSurface (owner->getColorSurface(), NULL, GraphicsData.gfx_tmp, NULL);
-	else SDL_FillRect (GraphicsData.gfx_tmp, NULL, 0x00FF00FF);
+	else SDL_FillRect (GraphicsData.gfx_tmp, NULL, 0xFFFF00FF);
 
 	if (data.hasFrames)
 	{
@@ -566,7 +565,7 @@
 	src.x = 0;
 	src.y = 0;
 
-	SDL_SetAlpha (GraphicsData.gfx_tmp, SDL_SRCALPHA, alpha);
+	SDL_SetSurfaceAlphaMod (GraphicsData.gfx_tmp, alpha);
 	SDL_BlitSurface (GraphicsData.gfx_tmp, &src, surface, &tmp);
 }
 
@@ -588,7 +587,6 @@
 	{
 		render_beton (surface, dest, zoomFactor);
 	}
-
 	// draw the connector slots:
 	if ( (this->SubBase && !StartUp) || data.isConnectorGraphic)
 	{
@@ -601,9 +599,9 @@
 	{
 		SDL_Rect tmp = dest;
 		if (StartUp && cSettings::getInstance().isAlphaEffects())
-			SDL_SetAlpha (uiData->shw, SDL_SRCALPHA, StartUp / 5);
+			SDL_SetSurfaceAlphaMod (uiData->shw, StartUp / 5);
 		else
-			SDL_SetAlpha (uiData->shw, SDL_SRCALPHA, 50);
+			SDL_SetSurfaceAlphaMod (uiData->shw, 50);
 
 		CHECK_SCALING (uiData->shw, uiData->shw_org, zoomFactor);
 		blittAlphaSurface (uiData->shw, NULL, surface, &tmp);
@@ -616,7 +614,7 @@
 		frameNr = (gameGUI->getAnimationSpeed() % data.hasFrames);
 	}
 
-	int alpha = 255;
+	int alpha = 254;
 	if (StartUp && cSettings::getInstance().isAlphaEffects()) alpha = StartUp;
 	render_simple (surface, dest, zoomFactor, frameNr, alpha);
 }
@@ -668,7 +666,6 @@
 	}
 	else
 	{
-
 		CHECK_NEIGHBOUR (PosX    , PosY - 1, BaseN)
 		CHECK_NEIGHBOUR (PosX + 1, PosY - 1, BaseBN)
 		CHECK_NEIGHBOUR (PosX + 2, PosY    , BaseE)
@@ -690,8 +687,8 @@
 	CHECK_SCALING (UnitsData.ptr_connector, UnitsData.ptr_connector_org, zoomFactor);
 	CHECK_SCALING (UnitsData.ptr_connector_shw, UnitsData.ptr_connector_shw_org, zoomFactor);
 
-	if (StartUp) SDL_SetAlpha (UnitsData.ptr_connector, SDL_SRCALPHA, StartUp);
-	else SDL_SetAlpha (UnitsData.ptr_connector, SDL_SRCALPHA, 255);
+	if (StartUp) SDL_SetSurfaceAlphaMod (UnitsData.ptr_connector, StartUp);
+	else SDL_SetSurfaceAlphaMod (UnitsData.ptr_connector, 254);
 
 	src.y = 0;
 	src.x = 0;
@@ -1346,6 +1343,7 @@
 	dest.x = x;
 	dest.y = y;
 
+	Uint32 color = SDL_MapRGB (sf->format, 0xFC, 0, 0);
 	for (int i = 0; i < value; i++)
 	{
 		if (i == orgvalue)
@@ -1356,7 +1354,7 @@
 			mark.y = dest.y;
 			mark.w = 1;
 			mark.h = src.h;
-			SDL_FillRect (sf, &mark, 0xFC0000);
+			SDL_FillRect (sf, &mark, color);
 		}
 
 		SDL_BlitSurface (GraphicsData.gfx_hud_stuff, &src, sf, &dest);
Index: buildings.h
===================================================================
--- buildings.h	(revision 3442)
+++ buildings.h	(working copy)
@@ -220,7 +220,7 @@
 	* draws the main image of the building onto the given surface
 	*/
 	void render (const cGameGUI* gameGUI, SDL_Surface* surface, const SDL_Rect& dest, float zoomFactor, bool drawShadow, bool drawConcrete);
-	void render_simple (SDL_Surface* surface, const SDL_Rect& dest, float zoomFactor, int frameNr, int alpha = 255);
+	void render_simple (SDL_Surface* surface, const SDL_Rect& dest, float zoomFactor, int frameNr, int alpha = 254);
 
 	void executeUpdateBuildingCommmand (const cClient& client, bool updateAllOfSameType);
 	void executeSelfDestroyCommand (cClient& client);
Index: client.cpp
===================================================================
--- client.cpp	(revision 3442)
+++ client.cpp	(working copy)
@@ -2005,7 +2005,7 @@
 #endif
 	// reset the screen
 	gameGUI->deselectUnit();
-	SDL_Surface* sf = SDL_CreateRGBSurface (SDL_SRCCOLORKEY, Video.getResolutionX(), Video.getResolutionY(), 32, 0, 0, 0, 0);
+	SDL_Surface* sf = SDL_CreateRGBSurface (0, Video.getResolutionX(), Video.getResolutionY(), 32, 0, 0, 0, 0);
 	SDL_Rect scr = { 15, 356, 112u, 112u};
 	SDL_BlitSurface (sf, NULL, buffer, NULL);
 	SDL_BlitSurface (sf, &scr, buffer, &scr);
Index: defines.h
===================================================================
--- defines.h	(revision 3446)
+++ defines.h	(working copy)
@@ -20,12 +20,12 @@
 #define definesH
 #include "settings.h"
 
-#define GRID_COLOR         0x00305C04 // color of the grid
-#define SCAN_COLOR         0x00E3E300 // color of scan circles
-#define RANGE_GROUND_COLOR 0x00E20000 // color of range circles for ground attack
-#define RANGE_AIR_COLOR    0x00FCA800 // color of range circles for air attack
-#define PFEIL_COLOR        0x000000FF // color of a waypointarrow
-#define PFEILS_COLOR       0x0000FF00 // color of a special waypointarrow
+#define GRID_COLOR         0xFF305C04 // color of the grid
+#define SCAN_COLOR         0xFFE3E300 // color of scan circles
+#define RANGE_GROUND_COLOR 0xFFE20000 // color of range circles for ground attack
+#define RANGE_AIR_COLOR    0xFFFCA800 // color of range circles for air attack
+#define PFEIL_COLOR        0xFF0000FF // color of a waypointarrow
+#define PFEILS_COLOR       0xFF00FF00 // color of a special waypointarrow
 #define MOVE_SPEED 2     // speed of vehiclemovements
 #define MSG_TICKS  30000 // number of ticks for how long a message will be displayed
 #define LANDING_DISTANCE_WARNING   28
@@ -33,7 +33,7 @@
 #define MAX_PLANES_PER_FIELD 5
 
 // minimap configuration
-#define MINIMAP_COLOR 0x00FC0000 // color of the screen borders on the minimap
+#define MINIMAP_COLOR 0xFFFC0000 // color of the screen borders on the minimap
 #define MINIMAP_POS_X 15         // the position of the map on the screen
 #define MINIMAP_POS_Y 356        // the position of the map on the screen
 #define MINIMAP_SIZE  112        // the size of the minimap in pixels
Index: dialog.cpp
===================================================================
--- dialog.cpp	(revision 3442)
+++ dialog.cpp	(working copy)
@@ -71,7 +71,7 @@
 	menuItems.push_back (&noButton);
 }
 
-void cDialogYesNo::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cDialogYesNo::handleKeyInput (const SDL_KeyboardEvent& key)
 {
 	switch (key.keysym.sym)
 	{
@@ -106,7 +106,7 @@
 	menuItems.push_back (&okButton);
 }
 
-void cDialogOK::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cDialogOK::handleKeyInput (const SDL_KeyboardEvent& key)
 {
 	if (key.keysym.sym == SDLK_RETURN)
 	{
@@ -248,7 +248,7 @@
 	draw();
 }
 
-void cDialogLicence::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cDialogLicence::handleKeyInput (const SDL_KeyboardEvent& key)
 {
 	if (key.keysym.sym == SDLK_RETURN)
 	{
@@ -632,13 +632,13 @@
 {
 	const int UNIT_IMAGE_SIZE = 64;
 
-	SDL_Surface* unitImage1 = SDL_CreateRGBSurface (SDL_SRCCOLORKEY, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_Surface* unitImage1 = SDL_CreateRGBSurface (0, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
 	SDL_FillRect (unitImage1, NULL, 0xFF00FF);
-	SDL_SetColorKey (unitImage1, SDL_SRCCOLORKEY, 0xFF00FF);
+	SDL_SetColorKey (unitImage1, SDL_TRUE, 0xFF00FF);
 
-	SDL_Surface* unitImage2 = SDL_CreateRGBSurface (SDL_SRCCOLORKEY, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_Surface* unitImage2 = SDL_CreateRGBSurface (0, UNIT_IMAGE_SIZE, UNIT_IMAGE_SIZE, Video.getColDepth(), 0, 0, 0, 0);
 	SDL_FillRect (unitImage2, NULL, 0xFF00FF);
-	SDL_SetColorKey (unitImage2, SDL_SRCCOLORKEY, 0xFF00FF);
+	SDL_SetColorKey (unitImage2, SDL_TRUE, 0xFF00FF);
 
 	SDL_Rect dest = {0, 0, 0, 0};
 
@@ -777,7 +777,7 @@
 		// little hack: flip part of the image that represent the arrow
 		const unsigned int w = 40;
 		const unsigned int h = 20;
-		SDL_Surface* arrowSurface = SDL_CreateRGBSurface (Video.getSurfaceType(), w, h, Video.getColDepth(), 0, 0, 0, 0);
+		SDL_Surface* arrowSurface = SDL_CreateRGBSurface (0, w, h, Video.getColDepth(), 0, 0, 0, 0);
 		const Sint16 x = arrowImage.getPosition().x - position.x; // 140
 		const Sint16 y = arrowImage.getPosition().y - position.y; //  77
 		SDL_Rect src = {x, y, w, h};
@@ -791,7 +791,7 @@
 	resBar->setCurrentValue ( (int) (223.f * (destCargo + transferValue) / maxDestCargo));
 }
 
-void cDialogTransfer::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cDialogTransfer::handleKeyInput (const SDL_KeyboardEvent& key)
 {
 	switch (key.keysym.sym)
 	{
@@ -994,7 +994,7 @@
 	}
 }
 
-void cDialogResearch::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cDialogResearch::handleKeyInput (const SDL_KeyboardEvent& key)
 {
 	switch (key.keysym.sym)
 	{
Index: dialog.h
===================================================================
--- dialog.h	(revision 3442)
+++ dialog.h	(working copy)
@@ -32,7 +32,7 @@
 	explicit cDialogYesNo (const std::string& text);
 
 private:
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 
 private:
 	cMenuLabel textLabel;
@@ -49,7 +49,7 @@
 	explicit cDialogOK (const std::string& text);
 
 private:
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 
 private:
 	cMenuLabel textLabel;
@@ -80,7 +80,7 @@
 	cDialogLicence();
 
 private:
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 
 private:
 	static void upReleased (void* parent);
@@ -201,7 +201,7 @@
 	~cDialogTransfer();
 
 private:
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 	virtual void handleDestroyUnit (cUnit& destroyedUnit);
 
 private:
@@ -244,7 +244,7 @@
 	explicit cDialogResearch (cClient& client_);
 
 private:
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 	virtual void handleDestroyUnit (cUnit& destroyedUnit);
 
 private:
Index: drawingcache.cpp
===================================================================
--- drawingcache.cpp	(revision 3442)
+++ drawingcache.cpp	(working copy)
@@ -77,10 +77,10 @@
 		width  = 130;
 		height = 130;
 	}
-	surface = SDL_CreateRGBSurface (SDL_SWSURFACE, width, height, 32, 0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);
+	surface = SDL_CreateRGBSurface (0, width, height, 32,
+									0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);
 
-	SDL_FillRect (surface, NULL, SDL_MapRGBA (surface->format, 255, 0, 255, 0));
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGBA (surface->format, 255, 0, 255, 0));
+	SDL_FillRect (surface, NULL, SDL_MapRGBA (surface->format, 0, 0, 0, 0));
 }
 
 void sDrawingCacheEntry::init (const cGameGUI& gameGUI, const cBuilding& building)
@@ -106,10 +106,10 @@
 	int width  = (int) std::max (building.uiData->img_org->w * zoom, building.uiData->shw_org->w * zoom);
 	if (building.data.hasFrames) width = (int) (building.uiData->shw_org->w * zoom);
 
-	surface = SDL_CreateRGBSurface (SDL_SWSURFACE, width, height, 32, 0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);
+	surface = SDL_CreateRGBSurface (0, width, height, 32,
+									0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);
 
-	SDL_FillRect (surface, NULL, SDL_MapRGBA (surface->format, 255, 0, 255, 0));
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGBA (surface->format, 255, 0, 255, 0));
+	SDL_FillRect (surface, NULL, SDL_MapRGBA (surface->format, 0, 0, 0, 0));
 }
 
 cDrawingCache::cDrawingCache()
@@ -346,7 +346,7 @@
 		return false;
 	}
 
-	if (vehicle.IsBuilding && vehicle.data.isBig && vehicle.BigBetonAlpha < 255)
+	if (vehicle.IsBuilding && vehicle.data.isBig && vehicle.BigBetonAlpha < 254u)
 	{
 		notCached++;
 		return false;
Index: events.cpp
===================================================================
--- events.cpp	(revision 3442)
+++ events.cpp	(working copy)
@@ -60,17 +60,6 @@
 	return screenshotfile;
 }
 
-static void HandleInputEvent_SDL_ACTIVEEVENT (SDL_Event& event)
-{
-	assert (event.type == SDL_ACTIVEEVENT);
-#if 1
-	// This is an workaround for a SDL bug.
-	// See Ticket #86 on bugtracker.
-	// will hopefully not be required anymore in SDL 1.3
-	if (event.active.state & SDL_APPINPUTFOCUS) SDL_SetModState (KMOD_NONE);
-#endif
-}
-
 static void HandleInputEvent_KEY (cMenu& activeMenu, SDL_Event& event, cClient* client)
 {
 	assert (event.type == SDL_KEYDOWN || event.type == SDL_KEYUP);
@@ -96,12 +85,14 @@
 {
 	switch (event.type)
 	{
-		case SDL_ACTIVEEVENT: HandleInputEvent_SDL_ACTIVEEVENT (event); break;
 		case SDL_KEYDOWN:
 		case SDL_KEYUP: HandleInputEvent_KEY (activeMenu, event, client); break;
 		case SDL_MOUSEBUTTONDOWN:
 		case SDL_MOUSEBUTTONUP: InputHandler->inputMouseButton (activeMenu, event.button); break;
+		case SDL_MOUSEWHEEL: InputHandler->inputMouseButton (activeMenu, event.wheel); break;
 		case SDL_QUIT: Quit(); break;
+		case SDL_MOUSEMOTION: break;
+		case SDL_WINDOWEVENT: Video.draw(); break;
 		default: break;
 	}
 }
Index: fxeffects.cpp
===================================================================
--- fxeffects.cpp	(revision 3442)
+++ fxeffects.cpp	(working copy)
@@ -293,7 +293,7 @@
 	CHECK_SCALING (images[1], images[0], gameGUI.getZoom());
 
 	const int alpha = (alphaEnd - alphaStart) * tick / length + alphaStart;
-	SDL_SetAlpha (images[1], SDL_SRCALPHA, alpha);
+	SDL_SetSurfaceAlphaMod (images[1], alpha);
 
 	SDL_Rect dest;
 	dest = gameGUI.calcScreenPos (posX - images[0]->w / 2, posY - images[0]->h / 2);
@@ -338,7 +338,7 @@
 	CHECK_SCALING (images[1], images[0], gameGUI.getZoom());
 
 	const int alpha = (alphaEnd - alphaStart) * tick / length + alphaStart;
-	SDL_SetAlpha (images[1], SDL_SRCALPHA, alpha);
+	SDL_SetSurfaceAlphaMod (images[1], alpha);
 
 	SDL_Rect src, dest;
 	src.y = 0;
@@ -473,6 +473,6 @@
 	dest = gameGUI.calcScreenPos ( (int) (posX + tick * dx), (int) (posY + tick * dy));
 
 	const int alpha = (alphaEnd - alphaStart) * tick / length + alphaStart;
-	SDL_SetAlpha (images[1], SDL_SRCALPHA, alpha);
+	SDL_SetSurfaceAlphaMod (images[1], alpha);
 	SDL_BlitSurface (images[1], &src, buffer, &dest);
 }
Index: hud.cpp
===================================================================
--- hud.cpp	(revision 3442)
+++ hud.cpp	(working copy)
@@ -151,7 +151,7 @@
 				string sTmpLine = " " + playerList[i]->getName() + ", nr: " + iToStr (playerList[i]->getNr()) + " << you! ";
 				// black out background for better recognizing
 				rBlackOut.w = font->getTextWide (sTmpLine, FONT_LATIN_SMALL_WHITE);
-				SDL_FillRect (buffer, &rBlackOut, 0x00000000);
+				SDL_FillRect (buffer, &rBlackOut, 0xFF000000);
 				font->showText (rBlackOut.x, debugOff + 1, sTmpLine, FONT_LATIN_SMALL_WHITE);
 			}
 			else
@@ -159,7 +159,7 @@
 				string sTmpLine = " " + playerList[i]->getName() + ", nr: " + iToStr (playerList[i]->getNr()) + " ";
 				// black out background for better recognizing
 				rBlackOut.w = font->getTextWide (sTmpLine, FONT_LATIN_SMALL_WHITE);
-				SDL_FillRect (buffer, &rBlackOut, 0x00000000);
+				SDL_FillRect (buffer, &rBlackOut, 0xFF000000);
 				font->showText (rBlackOut.x, debugOff + 1, sTmpLine, FONT_LATIN_SMALL_WHITE);
 			}
 			// use 10 for pixel high of dots instead of text high
@@ -823,8 +823,6 @@
 
 int cGameGUI::show (cClient* client)
 {
-	drawnEveryFrame = true;
-
 	// do startup actions
 	openPanel();
 	startup = true;
@@ -838,7 +836,7 @@
 		cEventHandling::handleInputEvents (*this, client);
 		client->gameTimer.run (this);
 
-		mouse->GetPos();
+		mouse->updatePos();
 		if (mouse->moved())
 		{
 			handleMouseMove();
@@ -1021,10 +1019,10 @@
 
 SDL_Surface* cGameGUI::generateSurface()
 {
-	SDL_Surface* surface = SDL_CreateRGBSurface (SDL_HWSURFACE, Video.getResolutionX(), Video.getResolutionY(), Video.getColDepth(), 0, 0, 0, 0);
+	SDL_Surface* surface = SDL_CreateRGBSurface (0, Video.getResolutionX(), Video.getResolutionY(), Video.getColDepth(), 0, 0, 0, 0);
 
 	SDL_FillRect (surface, NULL, 0x00FF00FF);
-	SDL_SetColorKey (surface, SDL_SRCCOLORKEY, 0x00FF00FF);
+	SDL_SetColorKey (surface, SDL_TRUE, 0x00FF00FF);
 
 	const std::string gfxPath = cSettings::getInstance().getGfxPath() + PATH_DELIMITER;
 	{
@@ -1260,7 +1258,7 @@
 
 SDL_Surface* cGameGUI::generateMiniMapSurface()
 {
-	SDL_Surface* minimapSurface = SDL_CreateRGBSurface (SDL_SWSURFACE, MINIMAP_SIZE, MINIMAP_SIZE, 32, 0, 0, 0, 0);
+	SDL_Surface* minimapSurface = SDL_CreateRGBSurface (0, MINIMAP_SIZE, MINIMAP_SIZE, 32, 0, 0, 0, 0);
 
 	// set zoom factor
 	const int displayedMapWidth = (int) ( (Video.getResolutionX() - HUD_TOTAL_WIDTH) / getZoom());
@@ -2940,7 +2938,7 @@
 	return true;
 }
 
-void cGameGUI::handleKeyInput (SDL_KeyboardEvent& key, const string& ch)
+void cGameGUI::handleKeyInput (const SDL_KeyboardEvent& key)
 {
 	if (key.keysym.sym == SDLK_LSHIFT || key.keysym.sym == SDLK_RSHIFT)
 	{
@@ -2981,7 +2979,7 @@
 		cDialogYesNo yesNoDialog (lngPack.i18n ("Text~Comp~End_Game"));
 		if (yesNoDialog.show (client) == 0) end = true;
 	}
-	else if (activeItem && !activeItem->isDisabled() && activeItem->handleKeyInput (key.keysym, ch, this))
+	else if (activeItem && !activeItem->isDisabled() && activeItem->handleKeyInput (key.keysym, this))
 	{}
 	else if (key.keysym.sym == KeysList.KeyJumpToAction)
 	{
@@ -3970,7 +3968,7 @@
 	const int mouseTopY = static_cast<int> (min (mouseBox.startY, mouseBox.endY) * getTileSize());
 	const int mouseBottomX = static_cast<int> (max (mouseBox.startX, mouseBox.endX) * getTileSize());
 	const int mouseBottomY = static_cast<int> (max (mouseBox.startY, mouseBox.endY) * getTileSize());
-	const Uint32 color = 0x00FFFF00;
+	const Uint32 color = 0xFFFFFF00;
 	SDL_Rect d;
 
 	d.x = mouseTopX - zoomOffX + HUD_LEFT_WIDTH;
@@ -4115,7 +4113,6 @@
 	while (top.y > -479)
 	{
 		Video.draw();
-		mouse->draw (false, screen);
 		SDL_Delay (10);
 		top.y -= 10;
 		bottom.y += 10;
@@ -4134,7 +4131,6 @@
 	while (bottom.y > Video.getResolutionY() / 2)
 	{
 		Video.draw();
-		mouse->draw (false, screen);
 		SDL_Delay (10);
 		top.y += 10;
 		if (top.y > (Video.getResolutionY() / 2) - 479 - 9) top.y = (Video.getResolutionY() / 2) - 479;
@@ -4147,7 +4143,6 @@
 		SDL_BlitSurface (GraphicsData.gfx_panel_bottom, NULL, buffer, &tmp);
 	}
 	Video.draw();
-	mouse->draw (false, screen);
 	SDL_Delay (100);
 }
 
@@ -5209,14 +5204,14 @@
 	r2.w = (int) ( ( (float) (r1.w - 2) / unit.data.ammoMax) * unit.data.ammoCur);
 	r2.h = r1.h - 2;
 
-	SDL_FillRect (buffer, &r1, 0);
+	SDL_FillRect (buffer, &r1, 0xFF000000);
 
 	if (unit.data.ammoCur > unit.data.ammoMax / 2)
-		SDL_FillRect (buffer, &r2, 0x0004AE04);
+		SDL_FillRect (buffer, &r2, 0xFF04AE04);
 	else if (unit.data.ammoCur > unit.data.ammoMax / 4)
-		SDL_FillRect (buffer, &r2, 0x00DBDE00);
+		SDL_FillRect (buffer, &r2, 0xFFDBDE00);
 	else
-		SDL_FillRect (buffer, &r2, 0x00E60000);
+		SDL_FillRect (buffer, &r2, 0xFFE60000);
 }
 
 //------------------------------------------------------------------------------
@@ -5245,15 +5240,15 @@
 	r2.w = (int) ( ( (float) (r1.w - 2) / unit.data.hitpointsMax) * unit.data.hitpointsCur);
 	r2.h = r1.h - 2;
 
-	SDL_FillRect (buffer, &r1, 0);
+	SDL_FillRect (buffer, &r1, 0xFF000000);
 
 	Uint32 color;
 	if (unit.data.hitpointsCur > unit.data.hitpointsMax / 2)
-		color = 0x0004AE04; // green
+		color = 0xFF04AE04; // green
 	else if (unit.data.hitpointsCur > unit.data.hitpointsMax / 4)
-		color = 0x00DBDE00; // orange
+		color = 0xFFDBDE00; // orange
 	else
-		color = 0x00E60000; // red
+		color = 0xFFE60000; // red
 	SDL_FillRect (buffer, &r2, color);
 }
 
Index: hud.h
===================================================================
--- hud.h	(revision 3442)
+++ hud.h	(working copy)
@@ -466,7 +466,7 @@
 
 	void updateInfoTexts();
 
-	virtual void handleKeyInput (SDL_KeyboardEvent& key, const std::string& ch);
+	virtual void handleKeyInput (const SDL_KeyboardEvent& key);
 
 	const cClient* getClient() const { return client; }
 	cClient* getClient() { return client; }
Index: input.cpp
===================================================================
--- input.cpp	(revision 3450)
+++ input.cpp	(working copy)
@@ -35,13 +35,15 @@
 cInput::cInput() :
 	LastClickTicks (0)
 {
+#if 0 // TODO: [SDL2]: setting for repeat key ?
 	// enables that SDL puts the unicode values to the keyevents.
 	SDL_EnableUNICODE (1);
 	// enables keyrepetition
 	SDL_EnableKeyRepeat (SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);
+#endif
 }
 
-void cInput::inputkey (cMenu& activeMenu, SDL_KeyboardEvent& key)
+void cInput::inputkey (cMenu& activeMenu, const SDL_KeyboardEvent& key)
 {
 	// give the key to the active menu
 	// But do not send events to a menu,
@@ -50,7 +52,7 @@
 	// after clicking the exit button
 	if (!activeMenu.exiting())
 	{
-		activeMenu.handleKeyInput (key, getUTF16Char (key.keysym.unicode));
+		activeMenu.handleKeyInput (key);
 	}
 }
 
@@ -86,8 +88,7 @@
 	}
 }
 
-
-void cInput::inputMouseButton (cMenu& activeMenu, SDL_MouseButtonEvent& button)
+void cInput::inputMouseButton (cMenu& activeMenu, const SDL_MouseButtonEvent& button)
 {
 	MouseState.x = button.x;
 	MouseState.y = button.y;
@@ -106,27 +107,7 @@
 			MouseState.rightButtonReleased = false;
 			MouseState.leftButtonReleased = false;
 		}
-		else if (button.button == SDL_BUTTON_WHEELUP)
-		{
-			MouseState.wheelUp = true;
-			MouseState.leftButtonReleased = false;
-			MouseState.rightButtonReleased = false;
-		}
-		else if (button.button == SDL_BUTTON_WHEELDOWN)
-		{
-			MouseState.wheelDown = true;
-			MouseState.leftButtonReleased = false;
-			MouseState.rightButtonReleased = false;
-		}
-
-		if (IsDoubleClicked())
-		{
-			MouseState.isDoubleClick = true;
-		}
-		else
-		{
-			MouseState.isDoubleClick = false;
-		}
+		MouseState.isDoubleClick = IsDoubleClicked();
 	}
 	else if (button.state == SDL_RELEASED)
 	{
@@ -142,8 +123,6 @@
 			MouseState.rightButtonReleased = true;
 			MouseState.leftButtonReleased = false;
 		}
-		else if (button.button == SDL_BUTTON_WHEELUP) MouseState.wheelUp = false;
-		else if (button.button == SDL_BUTTON_WHEELDOWN) MouseState.wheelDown = false;
 	}
 
 	// do not send events to a menu, after an event triggered the termination
@@ -155,6 +134,24 @@
 	}
 }
 
+void cInput::inputMouseButton (cMenu& activeMenu, const SDL_MouseWheelEvent& wheel)
+{
+	MouseState.wheelUp = false;
+	MouseState.wheelDown = false;
+	if (wheel.y > 0)
+	{
+		MouseState.wheelUp = true;
+		MouseState.leftButtonReleased = false;
+		MouseState.rightButtonReleased = false;
+	}
+	else if (wheel.y < 0)
+	{
+		MouseState.wheelDown = true;
+		MouseState.leftButtonReleased = false;
+		MouseState.rightButtonReleased = false;
+	}
+}
+
 std::string cInput::getUTF16Char (Uint16 ch)
 {
 	// convert from UTF-16 to UTF-8
Index: input.h
===================================================================
--- input.h	(revision 3442)
+++ input.h	(working copy)
@@ -45,14 +45,8 @@
 class cInput
 {
 private:
+	sMouseState MouseState;
 
-	sMouseState MouseState;
-	/**
-	 * Decodes the character from UTF-16 to UTF-8 and adds him to the input string.
-	 * @author alzi alias DoctorDeath
-	 * @param ch character which is to be added.
-	 */
-	std::string getUTF16Char (Uint16 ch);
 public:
 	cInput();
 	/**
@@ -60,13 +54,22 @@
 	 * If input is active the character will be added to the inpput string,
 	 * else the information will be given to the client to handle hotkeys.
 	 * @author alzi alias DoctorDeath
-	 * @param keysym SDL_keysym with pressed key information.
+	 * @param keysym SDL_Keysym with pressed key information.
 	 */
-	void inputkey (cMenu& activeMenu, SDL_KeyboardEvent& key);
+	void inputkey (cMenu& activeMenu, const SDL_KeyboardEvent& key);
 
 	long LastClickTicks;
-	void inputMouseButton (cMenu& avtiveMenu, SDL_MouseButtonEvent& button);
+	void inputMouseButton (cMenu& avtiveMenu, const SDL_MouseButtonEvent& button);
+	void inputMouseButton (cMenu& activeMenu, const SDL_MouseWheelEvent& wheel);
 	bool IsDoubleClicked();
+
+public:
+	/**
+	 * Decodes the character from UTF-16 to UTF-8 and adds him to the input string.
+	 * @author alzi alias DoctorDeath
+	 * @param ch character which is to be added.
+	 */
+	static std::string getUTF16Char (Uint16 ch);
 };
 
 EX cInput* InputHandler;
